import java.util.List;
import java.util.ListIterator;
import java.util.LinkedList;
import java.awt.Component;
import java.awt.event.*;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.Action;


public abstract class AbstractControlAction extends AbstractAction
{
	protected Component parent;
	protected List listConnectorForMVC;
//////	protected RobID thisID;
	private String currentMenuPath;
	private String currentToolBarName;


	protected AbstractControlAction(String name, Component parent)
	{
		super(name);
		this.parent = parent;
///////		currentMenuPath = IEnvironment.DEFAULT_MENU_PATH;
///////		currentToolBarName = IEnvironment.DEFAULT_TOOLBOX_NAME;
///////		thisID = new RobID(this); 
		listConnectorForMVC = new LinkedList();
	}


//////	protected AbstractControlAction(String name, String icon, Component parent)	{this(name, icon, " ", " ", IEnvironment.DEFAULT_MENU_PATH, parent);}
//////	protected AbstractControlAction(String name, String icon, String shortDescription, Component parent)	{this(name, icon, shortDescription, " ", IEnvironment.DEFAULT_MENU_PATH, parent);}
//////	protected AbstractControlAction(String name, String icon, String shortDescription, String longDescription, Component parent)	{this(name, icon, shortDescription, longDescription, IEnvironment.DEFAULT_MENU_PATH, parent);}
//////	protected AbstractControlAction(String name, String icon, String shortDescription, String longDescription, String menuPath, Component parent)	{this(name, icon, shortDescription, longDescription, menuPath, IEnvironment.DEFAULT_TOOLBOX_NAME, parent);}
	protected AbstractControlAction(String name, String icon, String shortDescription, String longDescription, String menuPath, String toolBarName, Component parent)
	{
		super(name, new ImageIcon(icon));
		this.parent = parent;
		super.putValue(Action.SHORT_DESCRIPTION, shortDescription);
		super.putValue(Action.LONG_DESCRIPTION, longDescription);
		currentMenuPath = menuPath;
		currentToolBarName = toolBarName;
///////		thisID = new RobID(this); 
		listConnectorForMVC = new LinkedList();
	}


///////	public int setState(RobID ident, int dataType, int param1, int param2, Object data) {return -1;}
///////	public RobID getID()	{return thisID;}


	public boolean addMenuItem()	{return true;}
	public String getMenuPath()	{return currentMenuPath;}
	public boolean setMenuPath(String newPath)
	{
		currentMenuPath = newPath;
		return true;
	}


	public boolean addToolBarItem()	{return false;}
	public String getToolBarName()	{return currentToolBarName;}
	public boolean setToolBarName(String newName)
	{
		currentToolBarName = newName;
		return true;
	}
}