package rob.math;

public class FunctionsZ
{
	private FunctionsZ()
	{
	}



/**
 * Funo que tira o mdulo de um inteiro.
 *@retorna o mdulo de um inteiro.
 */
	public static long mod(long num)
	{
		if (num > 0) 
			return num;
		return -num;
	}

/**
 * Funo que um inteiro num a um expoente inteiro exp.
 * Se exp for negativo, o valor retornado  multiplicado por 10000.
 */
	public static long power(long num, long exp)
	{
		if (exp == 0)
			return 1;

		boolean invert;
		if (exp < 0)
		{	
			exp = mod(exp);
			invert = true;
		}
		else
			invert = false;

		long counter, retValue, retValueTmp;
		retValue = 1;
		retValueTmp = num;
		counter = 1;
		while (counter <= exp)
		{
			if ((counter & exp) != 0)
				retValue *= retValueTmp;
			retValueTmp *= retValueTmp;
			counter = counter << 1;
		}

		if (invert)
			return inverse(retValue);
		return retValue;
	}

/**
 * A funcao fatorial calcula o fatorial de fator.
 */
	public static double fatorial(double fator)
	{
		long actualNumber, retValue;
		actualNumber = 0;
		retValue = 1;
		while (actualNumber < fator)
			retValue *= ++actualNumber;
		return retValue;
	}

/**
 * Funo que inverte um nmero inteiro.
 * O valor retornado  multiplicado por 10000.
 */
	public static long inverse(long num)
	{
		return 10000/num;
	}
}