package rob.math;

public abstract class MathConsts
{
	
	public static final double PI = 3.14159265;
	public static final double e = 2.718281828;

	public static final float infiniteFloat = Float.MAX_VALUE;
	public static final double infiniteDouble = Double.MAX_VALUE;
	public static final int infiniteInt = Integer.MAX_VALUE;
	public static final long infiniteLong = Long.MAX_VALUE;

	public static final double infinitesimalDouble = Double.MIN_VALUE;
	public static final float infinitesimalFloat = Float.MIN_VALUE;

	private MathConsts()
	{
	}
}