import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import java.util.List;
import java.util.ListIterator;
import java.util.LinkedList;
import rob.util.*;
import rob.math.*;
import rob.math.geom.*;


public class CrossingTest extends JFrame
{
	
	public JButton bUpdate = new JButton("Press me!");

	public ShapePolygon poly1, poly2;
	public TwoPolygonsCrossings polyCrosses;

	public CrossingTest()
	{
		bUpdate.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent evt)
			{
				repaint();
			}
		});
		this.getContentPane().add(bUpdate);
		setSize(1300, 1100);
		setVisible(true);
		
/****/
		List ll = new LinkedList();
		ll.add(new Point(180, 200));
		ll.add(new Point(210, 290));
		ll.add(new Point(100, 280));
		ll.add(new Point(150, 500));
		ll.add(new Point(400, 550));
		ll.add(new Point(250, 370));
		ll.add(new Point(270, 220));
		ll.add(new Point(450, 250));
		ll.add(new Point(300, 100));
		ll.add(new Point(40, 60));
		poly1 = new ShapePolygon(ll);

		List l2 = new LinkedList();
		l2.add(new Point(140, 180));
//////		l2.add(new Point(290, 210));
		l2.add(new Point(600, 160));
		l2.add(new Point(600, 501));
//////		l2.add(new Point(270, 220));
		l2.add(new Point(20, 501));
//////		l2.add(new Point(0, 0));
		poly2 = new ShapePolygon(l2);

/****/
	}

	public void update(Graphics g)
	{
		Graphics2D g2D = (Graphics2D) g;
		g2D.translate(100, 100);
		super.update(g);

		polyCrosses = new TwoPolygonsCrossings(poly1, poly2);
//////		polyCrosses = new TwoPolygonsCrossings(poly2, poly2);

		g2D.draw(poly1);
		g2D.draw(poly2);

		List newList = polyCrosses.getUnionDebug(g2D);
///////		List newList = polyCrosses.getIntersectionDebug(g2D);
		List newNewList = null;
		ListIterator newListIt = newList.listIterator();
		ShapePolygon poly = null;
		while (newListIt.hasNext())
		{
			newNewList = (List) newListIt.next();
			ListIterator newNewListIt = newNewList.listIterator();
			g.setColor(Color.blue);
			g2D.setStroke(new BasicStroke(2, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 2));
			while (newNewListIt.hasNext())
			{
				Point2D ptTmp = (Point2D) newNewListIt.next();
				g.drawOval((int) ptTmp.getX() - 1, (int) ptTmp.getY() - 1, 2, 2);
			}
			g.setColor(Color.orange);
			g2D.setStroke(new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 1));
			poly = new ShapePolygon(newNewList);
			g2D.draw(poly);
		}
		newList = polyCrosses.getCrossingsDebug(g2D);
		newListIt = newList.listIterator();
		g.setColor(Color.green);
		while (newListIt.hasNext())
		{
			Point2D ptTmp = (Point2D) newListIt.next();
			g.drawOval((int) ptTmp.getX() - 1, (int) ptTmp.getY() - 1, 2, 2);
		}
		g2D.setStroke(new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 1));
		poly = new ShapePolygon(newList);
		g2D.draw(poly);
	}


	public static void main(String [] args)
	{		
		CrossingTest cvs = new CrossingTest();
		cvs.repaint();
	}
}